package database;

import global.GlobalData;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.StringTokenizer;

public class RellenarGeografiaEspanola {
	
	//usaremos ficheros con el formato:
	//CodLUGAR	LUGAR	NOMBREPERNECENCIA

	public static void main( String args[] ) throws InterruptedException {
/**
 * args[0] = nombre del pais
 * args[1] = cdigo del pais
 * args[2] = nombre del fichero de comunidades autnomas
 * args[3] = nombre del fichero de provincias
 * args[4] = nombre del fichero de municipios
 * Los ficheros tendrn el formato: codLugar NombreLugar NombreLugarPertenencia
 * */
		
		Connection conn = null;
		String linea = null;
		FileReader fr = null;
		BufferedReader entrada = null;

		//----------  CONEXION A LA BD  ----------------
		
        try {
			Class.forName("com.mysql.jdbc.Driver");
			
	        //TODO controlar acceso identificado
	        conn = DriverManager.getConnection(GlobalData.url,GlobalData.login,GlobalData.password);

	        if (conn == null)
	        {
	           System.out.println("Conexin a base de datos "+GlobalData.url+" ... falhida");
	        }
	        
			//----------  INSERCION DEL PAIS  ----------------
			
	        try{
	            Statement st = conn.createStatement();		             
	            
	            st.executeUpdate("INSERT INTO geografia (LugarId, LugarNombre, Nivel)" +
	           		 "VALUES (" + Integer.parseInt(args[1]) + ",'" + args[0] + "','pais')");
	            //no es necesaria insercin en jerarqua por estar los pases en el nivel ms alto
	            //considerado de jerarqua
	            
	            //OJO!!! La  y las tildes se guardan "mal" pero las consultas desde Java son correctas
	            //las consultas desde la consola no funcionan por los caracteres especiales
	            ResultSet res = st.executeQuery("SELECT lugarNombre from geografia WHERE LugarId = 34");
	            res.next();
	            System.out.println(res.getString("lugarNombre"));
	          }
	          catch(SQLException se){
	            System.out.println(se);
	            System.out.println("Se prosigue a introducir los datos en la tabla relativos al pas ya existente");
	        }
	        
	        //---------  INSERCION DE COMUNIDADES AUTONOMAS  --------------

			fr = new FileReader(args[2]);	//args[2] -> fichero de autonomias
			entrada = new BufferedReader(fr);
			
	        while ((linea = entrada.readLine()) != null && (linea.length()>1))
			{
	        	introducirLugarEnBD(conn, linea, "autonomia");
		    }
	        fr.close();  
	        
	        //---------  INSERCION DE PROVINCIAS  --------------

			fr = new FileReader(args[3]);	//args[3] -> fichero de provincias
			entrada = new BufferedReader(fr);
			
	        while ((linea = entrada.readLine()) != null && (linea.length()>1))
			{
	        	introducirLugarEnBD(conn, linea, "provincia");
		    }
	        fr.close();  

	        //---------  INSERCION DE MUNICIPIOS  --------------

			fr = new FileReader(args[4]);	//args[2] -> fichero de autonomias
			entrada = new BufferedReader(fr);
			
	        while ((linea = entrada.readLine()) != null && (linea.length()>1))
			{
	        	introducirLugarEnBD(conn, linea, "municipio");
		    }
	        fr.close();  
	        
	        //------- FIN CONEXION A LA BD  ----------------
	        conn.close();
	        
		} catch (ClassNotFoundException e1) {
			e1.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
			System.out.println("Se prosigue a introducir el resto de datos en la tabla");
		} catch (FileNotFoundException e) {
			System.out.println("No se encuentran alguno o varios archivos de datos");
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
        
	}


//Guarda en la BD un lugar dado a travs de una lnea "linea" con el formato
//CodLugar NombreLugar NombreRegionALaQuePertenece
public static void introducirLugarEnBD(Connection conn, String linea, String nivel){
	
	StringTokenizer tok = new StringTokenizer(linea, "\t");
	String codLugarTemp = tok.nextToken();
	String lugarTemp = tok.nextToken();
	String perteneceTemp = tok.nextToken();
	int codPertenece = 0;
	String pertenece = null;
	int codLugar = 0;
	String [] nombresLugar = null;
	
	nombresLugar = obtenerNombresLugar(perteneceTemp);
	pertenece = nombresLugar[0];
	
	//obtener de la BD el cdigo de "pertenece"
    try{
    	int maximo = 0;
        Statement st = conn.createStatement();
        ResultSet res  = st.executeQuery("SELECT LugarId,Nivel FROM `geografia` " + 
				  "WHERE LugarNombre = '" + pertenece + "'");

        while(res.next()) {
        	//Buscamos el mximo "LugarId" con "nivel" superior en la jerarquia
        	if ((Integer.parseInt(res.getString("LugarId")) > maximo) && (res.getString("Nivel").compareToIgnoreCase(nivel) != 0)){
        		maximo = Integer.parseInt(res.getString("LugarId"));
        	}
        }
        codPertenece  = maximo;
    
    }catch(SQLException s){
        System.out.println(s);}
    
	//crear codLugar sumando "codpertenece" y "codLugarTemp"
    codLugar = Integer.parseInt(codPertenece + codLugarTemp);
    
    //separar lugarTemp en los nombres pertinentes
    nombresLugar = obtenerNombresLugar(lugarTemp);
	
    try{
        Statement st = conn.createStatement();
        
        //insertar en geografia las tuplas necesarias con los diferentes nombres y "codLugar"
        for (int j=0; j<nombresLugar.length; j++){
        	st.executeUpdate("INSERT INTO geografia (LugarId, LugarNombre, Nivel)" +
       		 "VALUES (" + codLugar + ",'" + nombresLugar[j] + "','" + nivel + "')");
        }
        
        //insertar en jerarquia UNA tupla con codLugar y codpertenece
        st.executeUpdate("INSERT INTO jerarquia (LugarId, perteneceA)" +
       		 "VALUES (" + codLugar + "," + codPertenece + ")");

      }
      catch(SQLException se){
        System.out.println(se);
    	System.out.println(nombresLugar[0] + " " + codLugar);
    }
}

//devuelve un vector String con todos los nombres de lugares extrados de
//nombreSinTratar, analizando caracteres los especiales "/", "(" y ")"
private static String[] obtenerNombresLugar(String nombreSinTratar) {
	StringTokenizer tk = new StringTokenizer(nombreSinTratar, "/");
	int numNombres = tk.countTokens();
	String [] nombresBarra = new String[numNombres];
	String [] nombresParentesis = new String[numNombres*2];
	
	//si hay varios nombres separados por una barra "/" los colocamos en nombresBarra
	for(int i=0; i<numNombres; i++){
		nombresBarra[i] = tk.nextToken();
	}
	
	
	//vemos si hay parntesis, en cuyo caso colocaremos como 
	//nombres posibles el nombre con y sin parntesis
	int k=0;
	for (int j=0; j<nombresBarra.length; j++, k++){
		StringTokenizer st = new StringTokenizer(nombresBarra[j], "(");
		nombresParentesis[k] = st.nextToken();
		
		//Si hay parntesis
		if (nombresBarra[j].length() != nombresParentesis[k].length()){
			k++;
			String esCapital = st.nextToken(")");
			//Si la palabra entre parntesis no es "Capital"
			if (esCapital.compareToIgnoreCase("Capital") != 0){
				nombresParentesis[k] = new String (esCapital.substring(1) + " " + nombresParentesis[k-1]);
			}
		}
	}
	
	//Todos los nombres obtenidos estn en "nombresParentesis" pero 
	//puede haber posiciones vacias
	String[] nombres = new String[k];
	for (int c=0; c<k; c++){
		//si hay comilla simple " ' " hay problemas al introducir en la BD con mysql
		//tenemos que aadir una ' para considerarla como caracter especial
		int ind = nombresParentesis[c].indexOf('\'');
		if (ind != -1){
			//si despus de ' hay espacio lo eliminamos -- por la generacion de nombres
			if (nombresParentesis[c].charAt(ind+1) == ' '){
				nombresParentesis[c] = new String (nombresParentesis[c].substring(0, ind+1) 
						+ nombresParentesis[c].substring(ind+2, nombresParentesis[c].length()-1));
			}
			nombresParentesis[c] = nombresParentesis[c].replace("'", "''");
		}
		nombres[c] = nombresParentesis[c].trim();
	}
	
	return nombres;
}


}